/*!
 * @author electricessence / https://github.com/electricessence/
 * Licensing: MIT https://github.com/electricessence/TypeScript.NET/blob/master/LICENSE.md
 * Based upon ObjectPool from Parallel Extension Extras and other ObjectPool implementations.
 * Uses .add(T) and .take():T
 */
!function(e){if("object"==typeof module&&"object"==typeof module.exports){var t=e(require,exports);void 0!==t&&(module.exports=t)}else"function"==typeof define&&define.amd&&define(["require","exports","./dispose","./DisposableBase","../Threading/Tasks/TaskHandler","../Exceptions/ArgumentOutOfRangeException","../Exceptions/ArgumentException","../../extends"],e)}(function(e,t){"use strict";var o=e("./dispose"),r=e("./DisposableBase"),n=e("../Threading/Tasks/TaskHandler"),i=e("../Exceptions/ArgumentOutOfRangeException"),s=e("../Exceptions/ArgumentException"),a=e("../../extends"),l=a["default"],u="ObjectPool",p="_maxSize",c=65536,f="Must be at valid number least 1.",h="Must be less than or equal to "+c+".",_=function(e){function t(t,o,r){if(e.call(this),this._maxSize=t,this._generator=o,this._recycler=r,this.autoClearTimeout=5e3,isNaN(t)||t<1)throw new i.ArgumentOutOfRangeException(p,t,f);if(t>c)throw new i.ArgumentOutOfRangeException(p,t,h);this._localAbsMaxSize=Math.min(2*t,c);var s=this;s._disposableObjectName=u,s._pool=[],s._trimmer=new n.TaskHandler(function(){return s._trim()});var a=function(){return s._clear()};s._flusher=new n.TaskHandler(a),s._autoFlusher=new n.TaskHandler(a)}return l(t,e),Object.defineProperty(t.prototype,"maxSize",{get:function(){return this._maxSize},enumerable:!0,configurable:!0}),Object.defineProperty(t.prototype,"count",{get:function(){var e=this._pool;return e?e.length:0},enumerable:!0,configurable:!0}),t.prototype._trim=function(){for(var e=this._pool;e.length>this._maxSize;)o.dispose.withoutException(e.pop())},t.prototype.trim=function(e){this.throwIfDisposed(),this._trimmer.start(e)},t.prototype._clear=function(){var e=this,t=e._pool;e._trimmer.cancel(),e._flusher.cancel(),e._autoFlusher.cancel(),o.dispose.these(t,!0),t.length=0},t.prototype.clear=function(e){this.throwIfDisposed(),this._flusher.start(e)},t.prototype.toArrayAndClear=function(){var e=this;e.throwIfDisposed(),e._trimmer.cancel(),e._flusher.cancel();var t=e._pool;return e._pool=[],t},t.prototype.dump=function(){return this.toArrayAndClear()},t.prototype._onDispose=function(){e.prototype._onDispose.call(this);var t=this;t._generator=null,t._recycler=null,o.dispose(t._trimmer,t._flusher,t._autoFlusher),t._trimmer=null,t._flusher=null,t._autoFlusher=null,t._pool.length=0,t._pool=null},t.prototype.extendAutoClear=function(){var e=this;e.throwIfDisposed();var t=e.autoClearTimeout;isFinite(t)&&!e._autoFlusher.isScheduled&&e._autoFlusher.start(t)},t.prototype.add=function(e){var t=this;if(t.throwIfDisposed(),t._pool.length>=t._localAbsMaxSize)o.dispose(e);else{t._recycler&&t._recycler(e),t._pool.push(e);var r=t._maxSize;r<c&&t._pool.length>r&&t._trimmer.start(500)}t.extendAutoClear()},t.prototype._onTaken=function(){var e=this,t=e._pool.length;t<=e._maxSize&&e._trimmer.cancel(),t&&e.extendAutoClear()},t.prototype.tryTake=function(){var e=this;e.throwIfDisposed();try{return e._pool.pop()}finally{e._onTaken()}},t.prototype.take=function(e){var t=this;if(t.throwIfDisposed(),!t._generator&&!e)throw new s.ArgumentException("factory","Must provide a factory if on was not provided at construction time.");try{return t._pool.pop()||e&&e()||t._generator()}finally{t._onTaken()}},t}(r.DisposableBase);t.ObjectPool=_,Object.defineProperty(t,"__esModule",{value:!0}),t["default"]=_});
//# sourceMappingURL=ObjectPool.js.map