/*!
 * @author electricessence / https://github.com/electricessence/
 * Licensing: MIT
 * Although most of the following code is written from scratch, it is
 * heavily influenced by Q (https://github.com/kriskowal/q) and uses some of Q's spec.
 */
!function(t){if("object"==typeof module&&"object"==typeof module.exports){var e=t(require,exports);void 0!==e&&(module.exports=e)}else"function"==typeof define&&define.amd&&define(["require","exports","../Types","../Threading/deferImmediate","../Disposable/DisposableBase","../Exceptions/InvalidOperationException","../Exceptions/ArgumentException","../Exceptions/ArgumentNullException","../Disposable/ObjectPool","../Collections/Set","../Threading/defer","../Disposable/ObjectDisposedException","../../extends"],t)}(function(t,e){"use strict";function n(t){return c["default"].hasMemberOfType(t,S,c["default"].FUNCTION)}function r(t,e,r){var o=e?e(t):t;return o&&n(o)?C.wrap(o):r(o)}function o(t,e,n){try{var r=n?n(e):e;return t&&t.resolve(r),null}catch(o){return t&&t.reject(o),o}}function i(t,e,n,r){try{var o=r?r(n):n;t&&t(o)}catch(i){e&&e(i)}}function s(t,e,n){t instanceof E?t.thenThis(e,n):t.then(e,n)}function u(t,e,n){return t instanceof E?t.thenSynchronous(e,n):t.then(e,n)}function l(){return new g.ObjectDisposedException("Promise","An underlying promise-result was disposed.")}var c=t("../Types"),a=t("../Threading/deferImmediate"),f=t("../Disposable/DisposableBase"),h=t("../Exceptions/InvalidOperationException"),p=t("../Exceptions/ArgumentException"),d=t("../Exceptions/ArgumentNullException"),v=t("../Disposable/ObjectPool"),w=t("../Collections/Set"),y=t("../Threading/defer"),g=t("../Disposable/ObjectDisposedException"),m=t("../../extends"),_=m["default"],b=void 0,j=null,D="Promise",I=D+"State",S="then",x="target",A=function(t){function e(e,n,r){t.call(this),this._state=e,this._result=n,this._error=r,this._disposableObjectName=I}return _(e,t),e.prototype._onDispose=function(){this._state=b,this._result=b,this._error=b},e.prototype.getState=function(){return this._state},Object.defineProperty(e.prototype,"state",{get:function(){return this._state},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isPending",{get:function(){return this.getState()===C.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isSettled",{get:function(){return this.getState()!=C.State.Pending},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isFulfilled",{get:function(){return this.getState()===C.State.Fulfilled},enumerable:!0,configurable:!0}),Object.defineProperty(e.prototype,"isRejected",{get:function(){return this.getState()===C.State.Rejected},enumerable:!0,configurable:!0}),e.prototype.getResult=function(){return this._result},Object.defineProperty(e.prototype,"result",{get:function(){return this.throwIfDisposed(),this.getResult()},enumerable:!0,configurable:!0}),e.prototype.getError=function(){return this._error},Object.defineProperty(e.prototype,"error",{get:function(){return this.throwIfDisposed(),this.getError()},enumerable:!0,configurable:!0}),e}(f.DisposableBase);e.PromiseState=A;var E=function(t){function e(){t.call(this,C.State.Pending),this._disposableObjectName=D}return _(e,t),e.prototype.then=function(t,e){var n=this;return this.throwIfDisposed(),new C(function(r,o){n.thenThis(function(e){return i(r,o,e,t)},function(t){return e?i(r,o,t,e):o(t)})})},e.prototype.thenAllowFatal=function(t,e){var n=this;return this.throwIfDisposed(),new C(function(r,o){n.thenThis(function(e){return r(t?t(e):e)},function(t){return o(e?e(t):t)})})},e.prototype.done=function(t,e){var n=this;y.defer(function(){return n.thenThis(t,e)})},e.prototype.delayFromNow=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),new C(function(n,r){y.defer(function(){e.thenThis(function(t){return n(t)},function(t){return r(t)})},t)},(!0))},e.prototype.delayAfterResolve=function(t){var e=this;return void 0===t&&(t=0),this.throwIfDisposed(),this.isSettled?this.delayFromNow(t):new C(function(n,r){e.thenThis(function(e){return y.defer(function(){return n(e)},t)},function(e){return y.defer(function(){return r(e)},t)})},(!0))},e.prototype["catch"]=function(t){return this.then(b,t)},e.prototype.catchAllowFatal=function(t){return this.thenAllowFatal(b,t)},e.prototype["finally"]=function(t){return this.then(t,t)},e.prototype.finallyAllowFatal=function(t){return this.thenAllowFatal(t,t)},e.prototype.finallyThis=function(t,e){this.throwIfDisposed();var n=e?t:function(){return a.deferImmediate(t)};return this.thenThis(n,n),this},e}(A);e.PromiseBase=E;var P=function(t){function e(){t.apply(this,arguments)}return _(e,t),e.prototype.thenSynchronous=function(t,e){this.throwIfDisposed();try{switch(this.state){case C.State.Fulfilled:return t?r(this._result,t,C.resolve):this;case C.State.Rejected:return e?r(this._error,e,C.resolve):this}}catch(n){return new R(n)}throw new Error("Invalid state for a resolved promise.")},e.prototype.thenThis=function(t,e){switch(this.throwIfDisposed(),this.state){case C.State.Fulfilled:t&&t(this._result);break;case C.State.Rejected:e&&e(this._error)}return this},e}(E);e.Resolvable=P;var O=function(t){function e(e,n,r){t.call(this),this._result=n,this._error=r,this._state=e}return _(e,t),e}(P);e.Resolved=O;var F=function(t){function e(e){t.call(this,C.State.Fulfilled,e)}return _(e,t),e}(O);e.Fulfilled=F;var R=function(t){function e(e){t.call(this,C.State.Rejected,b,e)}return _(e,t),e}(O);e.Rejected=R;var T=function(t){function e(e){var r=this;if(t.call(this),this._target=e,!e)throw new d.ArgumentNullException(x);if(!n(e))throw new p.ArgumentException(x,"Must be a promise-like object.");e.then(function(t){r._state=C.State.Fulfilled,r._result=t,r._error=b,r._target=b},function(t){r._state=C.State.Rejected,r._error=t,r._target=b})}return _(e,t),e.prototype.thenSynchronous=function(e,n){this.throwIfDisposed();var r=this._target;return r?new C(function(t,o){s(r,function(n){return i(t,o,n,e)},function(e){return n?i(t,null,e,n):o(e)})},(!0)):t.prototype.thenSynchronous.call(this,e,n)},e.prototype.thenThis=function(e,n){this.throwIfDisposed();var r=this._target;return r?(s(r,e,n),this):t.prototype.thenThis.call(this,e,n)},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._target=b},e}(P),C=function(t){function e(e,n){void 0===n&&(n=!1),t.call(this),e&&this.resolveUsing(e,n)}return _(e,t),e.prototype.thenSynchronous=function(n,r){if(this.throwIfDisposed(),this._state)return t.prototype.thenSynchronous.call(this,n,r);var o=new e;return(this._waiting||(this._waiting=[])).push(B.PromiseCallbacks.init(n,r,o)),o},e.prototype.thenThis=function(e,n){return this.throwIfDisposed(),this._state?t.prototype.thenThis.call(this,e,n):((this._waiting||(this._waiting=[])).push(B.PromiseCallbacks.init(e,n)),this)},e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._resolvedCalled=b},e.prototype.resolveUsing=function(t,n,r){var o=this;if(void 0===n&&(n=!1),void 0===r&&(r=!1),!t)throw new d.ArgumentNullException("resolver");if(this._resolvedCalled)throw new h.InvalidOperationException(".resolve() already called.");if(this.state)throw new h.InvalidOperationException("Already resolved: "+e.State[this.state]);this._resolvedCalled=!0;var i=0,s=function(t){i?console.warn(i==-1?"Rejection called multiple times":"Rejection called after fulfilled."):(i=-1,o._resolvedCalled=!1,o.reject(t))},u=function(t){i?console.warn(1==i?"Fulfill called multiple times":"Fulfill called after rejection."):(i=1,o._resolvedCalled=!1,o.resolve(t))};n?t(u,s):a.deferImmediate(function(){return t(u,s)})},e.prototype._emitDisposalRejection=function(t){var e=t.wasDisposed;return e&&this._rejectInternal(l()),e},e.prototype._resolveInternal=function(t){var r=this;if(!this.wasDisposed){for(;t instanceof E;){var i=t;if(this._emitDisposalRejection(i))return;switch(i.state){case e.State.Pending:return void i.thenSynchronous(function(t){return r._resolveInternal(t)},function(t){return r._rejectInternal(t)});case e.State.Rejected:return void this._rejectInternal(i.error);case e.State.Fulfilled:t=i.result}}if(n(t))t.then(function(t){return r._resolveInternal(t)},function(t){return r._rejectInternal(t)});else{this._state=e.State.Fulfilled,this._result=t,this._error=b;var s=this._waiting;if(s){this._waiting=b;for(var u=0,l=s;u<l.length;u++){var c=l[u],a=c.onFulfilled,f=c.promise;B.PromiseCallbacks.recycle(c),o(f,t,a)}s.length=0}}}},e.prototype._rejectInternal=function(t){if(!this.wasDisposed){this._state=e.State.Rejected,this._error=t;var n=this._waiting;if(n){this._waiting=null;for(var r=0,i=n;r<i.length;r++){var s=i[r],u=s.onRejected,l=s.promise;B.PromiseCallbacks.recycle(s),u?o(l,t,u):l&&l.reject(t)}n.length=0}}},e.prototype.resolve=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),t==this)throw new h.InvalidOperationException("Cannot resolve a promise as itself.");if(this._state){if(!n||this._state==e.State.Fulfilled&&this._result===t)return;throw new h.InvalidOperationException("Changing the fulfilled state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new h.InvalidOperationException(".resolve() already called.")}else this._resolveInternal(t)},e.prototype.reject=function(t,n){if(void 0===n&&(n=!1),this.throwIfDisposed(),this._state){if(!n||this._state==e.State.Rejected&&this._error===t)return;throw new h.InvalidOperationException("Changing the rejected state/value of a promise is not supported.")}if(this._resolvedCalled){if(n)throw new h.InvalidOperationException(".resolve() already called.")}else this._rejectInternal(t)},e}(P);e.Promise=C;var N=function(t){function e(){t.apply(this,arguments)}return _(e,t),e.prototype.map=function(t){var n=this;return this.throwIfDisposed(),new e(function(e){n.thenThis(function(n){return e(n.map(t))})},(!0))},e.prototype.reduce=function(t,e){return this.thenSynchronous(function(n){return n.reduce(t,e)})},e.fulfilled=function(t){return new e(function(e){return t},(!0))},e}(C);e.ArrayPromise=N;var k=function(t){function e(e){t.call(this),this._source=e&&e.slice()||[]}return _(e,t),e.prototype._onDispose=function(){t.prototype._onDispose.call(this),this._source.length=0,this._source=null},Object.defineProperty(e.prototype,"promises",{get:function(){return this.throwIfDisposed(),this._source.slice()},enumerable:!0,configurable:!0}),e.prototype.all=function(){return this.throwIfDisposed(),C.all(this._source)},e.prototype.race=function(){return this.throwIfDisposed(),C.race(this._source)},e.prototype.waitAll=function(){return this.throwIfDisposed(),C.waitAll(this._source)},e.prototype.map=function(t){var e=this;return this.throwIfDisposed(),new N(function(n){e.all().thenThis(function(e){return n(e.map(t))})},(!0))},e.prototype.pipe=function(t){return this.throwIfDisposed(),new e(this._source.map(function(e){return u(e,t)}))},e.prototype.reduce=function(t,e){return this.throwIfDisposed(),C.wrap(this._source.reduce(function(e,n,r,o){return u(e,function(e){return u(n,function(n){return t(e,n,r,o)})})},n(e)?e:new F(e)))},e}(f.DisposableBase);e.PromiseCollection=k;var B;!function(t){var e;!function(t){function e(){return i||(i=new v.ObjectPool(40,n,function(t){t.onFulfilled=j,t.onRejected=j,t.promise=j}))}function n(){return{onFulfilled:j,onRejected:j,promise:j}}function r(t,n,r){var o=e().take();return o.onFulfilled=t,o.onRejected=n,o.promise=r,o}function o(t){e().add(t)}var i;t.init=r,t.recycle=o}(e=t.PromiseCallbacks||(t.PromiseCallbacks={}))}(B||(B={}));var C;!function(t){function e(e){return new t(e)}function r(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("promises");return new k((Array.isArray(t)?t:[t]).concat(e))}function o(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("promises");var r=(Array.isArray(t)?t:[t]).concat(e);return!r.length||r.every(function(t){return!t})?new N(function(t){return t(r)},(!0)):new N(function(t,e){var n=[],o=r.length;n.length=o;for(var i=new w.Set(r.map(function(t,e){return e})),s=function(){e=b,t=b,r.length=0,r=b,i.dispose(),i=b},u=function(){var e=t;e&&!i.count&&(s(),e(n))},l=function(e,r){t&&(n[r]=e,i.remove(r),u())},c=function(t){var n=e;n&&(s(),n(t))},a=function(t){var e=r[t];e?e.then(function(e){return l(e,t)},c):i.remove(t),u()},f=0;i&&f<o;f++)a(f)})}function i(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("promises");var r=(Array.isArray(t)?t:[t]).concat(e);return!r.length||r.every(function(t){return!t})?new N(function(t){return t(r)},(!0)):new N(function(t,e){for(var n=r.length,o=new w.Set(r.map(function(t,e){return e})),i=function(){e=j,t=j,o.dispose(),o=j},s=function(){var e=t;e&&!o.count&&(i(),e(r))},u=function(t){o&&(o.remove(t),s())},l=function(t){var e=r[t];e?e.then(function(e){return u(t)},function(e){return u(t)}):u(t)},c=0;o&&c<n;c++)l(c)})}function s(e){for(var n=[],r=1;r<arguments.length;r++)n[r-1]=arguments[r];var o=e&&(Array.isArray(e)?e:[e]).concat(n);if(!o||!o.length||!(o=o.filter(function(t){return null!=t})).length)throw new p.ArgumentException("Nothing to wait for.");var i=o.length;if(1==i)return h(o[0]);for(var s=0;s<i;s++){var u=o[s];if(u instanceof E&&u.isSettled)return u}return new t(function(t,e){for(var n=function(){e=j,t=j,o.length=0,o=j},r=function(t,e){t&&(n(),t(e))},i=function(e){return r(t,e)},s=function(t){return r(e,t)},u=0,l=o;u<l.length;u++){var c=l[u];if(!t)break;c.then(i,s)}})}function u(t){return n(t)?h(t):new F(t)}function l(e,n){return void 0===n&&(n=!1),new t(e,n)}function c(t){for(var e=[],n=1;n<arguments.length;n++)e[n-1]=arguments[n];if(!t&&!e.length)throw new d.ArgumentNullException("resolutions");return new k((Array.isArray(t)?t:[t]).concat(e).map(function(t){return u(t)}))}function a(e,n){return new k(e.map(function(e){return new t(function(t,r){try{t(n(e))}catch(o){r(o)}})}))}function f(t){return new R(t)}function h(t){if(!t)throw new d.ArgumentNullException(x);return n(t)?t instanceof E?t:new T(t):new F(t)}function v(t){if(!t)throw new d.ArgumentNullException(S);return new T({then:t})}!function(t){t[t.Pending=0]="Pending",t[t.Fulfilled=1]="Fulfilled",t[t.Rejected=-1]="Rejected"}(t.State||(t.State={}));var y=t.State;Object.freeze(y),t.factory=e,t.group=r,t.all=o,t.waitAll=i,t.race=s,t.resolve=u,t.using=l,t.resolveAll=c,t.map=a,t.reject=f,t.wrap=h,t.createFrom=v}(C=e.Promise||(e.Promise={})),Object.defineProperty(e,"__esModule",{value:!0}),e["default"]=C});
//# sourceMappingURL=Promise.js.map